@make(ais)
@aiInfo(topic=<A main program can be given by a generic instantiation>,
number=[AI-00513/08],
classcode=[BI],
statuscode=[WA],
mainref=[10.01@\(08)],
date=[88-11-04])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
!class binding interpretation 87-09-15
@cbon()!status approved by WG9 88-10-28@cboff()
@end(toplines)
!status ARG-approved (14-0-3) 88-06-07 (by ballot)
!status ARG-approved 88-05-10 (reviewed; pending letter ballot)
!status ARG-approved (14-0-2) 87-09-15 (pending editorial review; ballot)
!status panel-approved (4-0-2) 87-09-15 (pending editorial review; ballot)
!status panel/committee-approved (9-0-0) 87-02-17 (pending editorial review)
!status work-item 87-01-16
!status received 87-01-13
@references[!references AI-00199, @CommentNum[83-00876]83-00876, @CommentNum[83-00878]83-00878, @CommentNum[83-00877]83-00877, @CommentNum[83-00911]83-00911, @CommentNum[83-00918]83-00918]
@topic{!topic A main program can be given by a generic instantiation}
@end(history)

@subheading[!summary 88-03-07]

A subprogram instantiation that is a library unit can be used as a main
program if the instance has the parameter and result type profile required for
a main program.

@subheading[!question @cbon()88-11-04]@cboff()

Can a subprogram that is created by a generic instantiation be used as a main
program?  10.1(8) says:
@begin(quotation)
A subprogram that is a library unit can be used as a @i[main program]
in the usual sense. @ellipsis() An implementation may impose certain
requirements on the parameters and on the result, if any, of a main
program (these requirements must be stated in Appendix F).  In any
case, every implementation is required to allow, at least, main
programs that are parameterless procedures, and every main program
must be a subprogram that is a library unit.
@end(quotation)
12(2) says:
@begin(quotation)
An instance of a generic subprogram is a subprogram.
@end(quotation)
If a generic subprogram instantiation is compiled as a library unit, is the
instance @dq{a subprogram that is a library unit?}  If so, this paragraph
seems to say that such an instance can be used as a main program (as
long as it has an appropriate parameter and result type profile).  However,
10.1(6) says:
@begin(quotation)
A subprogram body given in a compilation unit is interpreted as a
secondary unit if the program library already contains a library unit
that is a subprogram with the same name; it is otherwise interpreted
both as a library unit and as the corresponding library unit body
(that is, as a secondary unit).
@end(quotation)
Suppose a subprogram instantiation is compiled as a library unit.  Presumably
this means the library now contains a subprogram having the name of the
instance.  If so, 10.1(6) seems to say that a later compilation of a
@cbon()subprogram body@cboff() having the same identifier would mean the subprogram body is
a secondary unit, and hence, must conform to the specification provided by
the instance.  However, AI-00199 (a binding interpretation) forbids this
interpretation by stating:
@begin(quotation)
A subprogram body given in a compilation unit (following the context
clause) is interpreted as a secondary unit if the program library
already contains a subprogram declaration or generic subprogram
declaration with the same identifier; it is otherwise interpreted as
a library unit.
@end(quotation)
Given 10.1(6), AI-00199 seems to imply that a generic instantiation cannot
create a @dq{subprogram that is a library unit.}  For example, if GP is a
generic procedure:
@begin(example)
-- compile an instance
@key[procedure] M @key[is] @key[new] GP;
@hinge()

-- compile a different body named M
@key[procedure] M @key[is]
@key[begin] ... @key[end] M;
@end(example)
The first compilation makes M a library unit.  When procedure body M is later
compiled, AI-00199 says that the body replaces the library unit instance.
Since the procedure body is, therefore, not interpreted as a secondary unit,
10.1(6) implies the library did not already contain @dq{a library unit that is a
subprogram with the same name.}  If so, 10.1(8) implies that such an
instantiation cannot serve as a main program.  Is this conclusion correct?

@subheading[!recommendation 88-03-07]

A subprogram instantiation that is a library unit can be used as a main
program if the instance has the parameter and result type profile required for
a main program.

@subheading[!discussion @cbon()88-11-04]@cboff()

The wording in 10.1(6) only intended to say that when a compilation unit is a
@cbon()subprogram body,@cboff() the body is not considered to be a library unit if the
library already contains an identically named generic or nongeneric
subprogram unit that requires a body.  AI-00199 makes this intent explicit.

10.1(8) uses @dq{subprogram} in a different sense.  10.1(8) only intends to
specify that a main program can be a procedure or a function, a main program
can have parameters, and every implementation must at least allow
parameterless procedures to be main programs.  There was no intent to
distinguish between subprogram library units that require a body and those
that do not; in particular, there was no intent to exclude subprograms
declared by instantiation.

